package com.example

import com.example.config.JwtConfig
import com.example.di.configureDependencyInjection
import com.example.security.JwtManager
import io.ktor.server.application.*
import org.koin.ktor.plugin.Koin

fun main(args: Array<String>) {
    io.ktor.server.netty.EngineMain.main(args)
}

fun Application.module() {
    install(Koin){
        modules(configureDependencyInjection(this@module))
    }
    configureSecurity()
    configureSerialization()
    configureRouting()
}
