package com.example.repository

import com.example.command.request.GetAuthByEmailCommand
import com.example.command.request.InsertAuthCommand
import com.example.command.request.UpdateAuthByEmailCommand
import com.example.model.AuthEntity

class AuthRepositoryImpl: AuthRepository {
    private val users = mutableListOf(
        AuthEntity(
            userId = 1,
            userName = "user1",
            email = "user1@mail.ru",
            password = "123"
        ),
        AuthEntity(
            userId = 2,
            userName = "user2",
            email = "user2@mail.ru",
            password = "123"
        ),
        AuthEntity(
            userId = 3,
            userName = "user3",
            email = "user3@mail.ru",
            password = "123"
        ),
    )
    override suspend fun getAuthByEmail(getAuthByEmailCommand: GetAuthByEmailCommand): AuthEntity? {
        return users.find { it.email == getAuthByEmailCommand.email }
    }

    override suspend fun updateAuthByEmail(updateAuthByEmailCommand: UpdateAuthByEmailCommand): Boolean {
        val user = users.find { it.email == updateAuthByEmailCommand.email }
        if (user != null) {
            user.update(updateAuthByEmailCommand)
            return true
        }
        return false
    }

    override suspend fun insertAuth(insertAuthCommand: InsertAuthCommand): AuthEntity {
        val authEntity = AuthEntity(
            userId = users.size + 1,
            userName = insertAuthCommand.userName,
            password = insertAuthCommand.password,
            email = insertAuthCommand.email
        )
        return authEntity
    }
}