package com.example.security

import com.auth0.jwt.JWT
import com.auth0.jwt.JWTVerifier
import com.auth0.jwt.algorithms.Algorithm
import com.example.config.JwtConfig
import java.util.*

class JwtManager(private val jwtConfig: JwtConfig) {
    fun createJwt(): String{
        return JWT.create()
            .withAudience(jwtConfig.jwtAudience)
            .withIssuer(jwtConfig.jwtIssue)
            .withExpiresAt(Date(System.currentTimeMillis() + 7 * 24 * 60 * 60 * 1000))
            .sign(Algorithm.HMAC256(jwtConfig.jwtSecret))

    }
    fun verifyJwt(): JWTVerifier{
      return  JWT
            .require(Algorithm.HMAC256(jwtConfig.jwtSecret))
            .withAudience(jwtConfig.jwtAudience)
            .withIssuer(jwtConfig.jwtIssue)
            .build()
    }
}