package com.example.service

import com.example.command.request.GetAuthByEmailCommand
import com.example.common.Either
import com.example.dto.request.LoginRequest
import com.example.dto.response.LoginResponse
import com.example.repository.AuthRepository
import com.example.security.JwtManager
import com.example.service.exception.ErrorService

class AuthServiceImpl(
    private val authRepository: AuthRepository,
    private val jwtManager: JwtManager
) {
    suspend fun login(loginRequest: LoginRequest): Either<ErrorService, LoginResponse>{
        val getAuthByEmailCommand = GetAuthByEmailCommand(loginRequest.email)
        val user = authRepository.getAuthByEmail(getAuthByEmailCommand) ?: return Either.Left(ErrorService.NOT_FOUND)
        if(user.password == loginRequest.password){
                val token = jwtManager.createJwt()
                val response = LoginResponse(token = token)
                return Either.Right(response)
            }
        return Either.Left(ErrorService.UNAUTHORIZED)
    }
    suspend fun registration(){
    }
    suspend fun resetPassword(){
    }
}